﻿(defun C:STICKEMS ()

  (prompt "\nSTICKEMS - Attach notes to drawing entities")

  (initget 1 "R W")
  (setq	CHOICE (getkword
		"\nDo you want to Read or Write a note <R or W> ? "
		)
	)

  (while (null (setq ENTITY (car (entsel)))))

  (if (equal CHOICE "W")
    (progn

      (textpage)

      (setq NAME (getstring "\nWhat is your first name ? "))
      (setq NAME (strcat "STICKEMS"
			(substr (rtos (getvar "CDATE") 2 8) 1 8)
			(substr (rtos (getvar "CDATE") 2 8) 10 8)
			NAME
			)
	   )
      (regapp NAME)

      (setq ENTLIST (entget ENTITY (list "*")))

      (prompt
	"\nEnter your note line by line. When you are through"
	)
      (prompt "\ntype the word EXIT on a line by itself.\n")

      (setq NEW_XDATA (list NAME (cons 1002 "{")))
      (while (/= "EXIT" (strcase (setq STRING (getstring T ">"))))
	(setq NEW_XDATA (append NEW_XDATA (list (cons 1000 STRING))))
	)
      (setq NEW_XDATA (append NEW_XDATA (list (cons 1002 "}"))))
      (setq NEW_XDATA (list -3 NEW_XDATA))

      (if (assoc -3 ENTLIST)
	(setq NEW_ENTLIST (subst NEW_XDATA (assoc -3 ENTLIST) ENTLIST))
	(setq NEW_ENTLIST (append ENTLIST (list NEW_XDATA)))
	)
      (entmod NEW_ENTLIST)
      )
    )

  (if (equal CHOICE "R")
    (progn

      (setq ENTLIST (entget ENTITY (list "STICKEMS*")))
      (setq XDATA (cdr (assoc -3 ENTLIST)))

      (if (null XDATA)

	(prompt "\nEntity does not have any STICKEMS.")

	(progn
	 (foreach ITEM	XDATA

	   (textpage)

	   (setq DATE (substr (car ITEM) 9 8))
	   (setq TIME (substr (car ITEM) 17 8))
	   (setq NAME (substr (car ITEM) 25))

	   (prompt (strcat "Posted by " NAME " on " DATE " at " TIME))

	   (setq NOTES (cdr ITEM))
	   (foreach LINE NOTES
	     (if (= (car LINE) 1000)
		(prompt (strcat "\n" (cdr LINE)))
		)
	     )

	   (getstring "\n\nHit any key to continue ...")
	   )
	 )
	)
      )
    )

  (prompt "\nProgram complete.")
  (princ)
  )